/*------------------------------*/
/*  Intro a la programac de     */
/*  juegos, por Nacho Cabanes   */
/*                              */
/*   Hardware.h:                */
/*     Clase "Hardware"         */
/*       para Allegro           */
/*     Fichero de cabecera      */
/*                              */
/*     Parte de "MiniMiner"     */
/*                              */
/*  Ejemplo:                    */
/*    Primer acercamiento a     */
/*    "MiniMiner"               */
/*                              */
/*  Comprobado con:             */
/*  - DevC++ 4.9.9.2(gcc 3.4.2) */
/*    y Allegro 4.03 - WinXP    */
/*------------------------------*/

#ifndef Hardware_h
#define Hardware_h

#include <vector>
#include <string>
using namespace std;

#include <allegro.h>


#include "ElementoGraf.h"

#define TECLA_ESC KEY_ESC
#define TECLA_DCHA KEY_RIGHT
#define TECLA_ARRB KEY_UP
#define TECLA_ABAJ KEY_DOWN
#define TECLA_IZQD KEY_LEFT
#define TECLA_ESPACIO KEY_SPACE
#define TECLA_A KEY_A
#define TECLA_B KEY_B
#define TECLA_C KEY_C
#define TECLA_D KEY_D
#define TECLA_E KEY_E
#define TECLA_F KEY_F
#define TECLA_G KEY_G
#define TECLA_H KEY_H
#define TECLA_I KEY_I
#define TECLA_J KEY_J
#define TECLA_K KEY_K
#define TECLA_L KEY_L
#define TECLA_M KEY_M
#define TECLA_N KEY_N
#define TECLA_O KEY_O
#define TECLA_P KEY_P
#define TECLA_Q KEY_Q
#define TECLA_R KEY_R
#define TECLA_S KEY_S
#define TECLA_T KEY_T
#define TECLA_U KEY_U
#define TECLA_V KEY_V
#define TECLA_W KEY_W
#define TECLA_X KEY_X
#define TECLA_Y KEY_Y
#define TECLA_Z KEY_Z

#define TECLA_0 KEY_0
#define TECLA_1 KEY_1
#define TECLA_2 KEY_2
#define TECLA_3 KEY_3
#define TECLA_4 KEY_4
#define TECLA_5 KEY_5
#define TECLA_6 KEY_6
#define TECLA_7 KEY_7
#define TECLA_8 KEY_8
#define TECLA_9 KEY_9

#define TECLA_F1 KEY_F1

class Hardware {

 public:

    //Hardware();
    void inicializar(int ancho, int alto);
    bool comprobarTecla();

    bool comprobarTecla(int codigoTecla);
    int esperarTecla();
    void vaciarBufferTeclado();
    bool algunaTeclaPulsada();


    void borrarOculta();
    void dibujarOculta(ElementoGraf e);

    void visualizarOculta();

    void pausa(long ms);

 private:

    int anchoPantalla;
    int altoPantalla;

    BITMAP *pantallaOculta;
    int maxX;
    int maxY;
    int colores;
    int teclaPulsada;
    int posXRaton;
    int posYRaton;

 private:

    BITMAP pantallaVisible;
    BITMAP fondo;


};
#endif
