/*------------------------------*/
/*  Intro a la programac de     */
/*  juegos, por Nacho Cabanes   */
/*                              */
/*   Nivel.h:                   */
/*     La pantalla del nivel 1  */
/*     Miniminer (version 0.07) */
/*     Fichero de cabecera      */
/*                              */
/*  Comprobado con:             */
/*  - DevC++ 4.9.9.2(gcc 3.4.2) */
/*    y Allegro 4.03 - WinXP    */
/*------------------------------*/


#ifndef Nivel_h
#define Nivel_h

#include <vector>
#include <string>
using namespace std;


#include "ElementoGraf.h"


class Nivel {

 public:

    Nivel();
    void dibujarOculta(Hardware h);
    void leerDeFichero();
    bool esPosibleMover(int x1, int y1, int x2, int y2);

 private:
    int nivelActual;
    
       /* El mapa que representa a la pantalla */
       /* 16 filas y 32 columnas (de 16x16 cada una) */
    #define MAXFILAS 16
    #define MAXCOLS  32
    
    int anchoImagen, altoImagen;
    int margenIzq, margenSup;

    char mapa[MAXFILAS][MAXCOLS];
    ElementoGraf *fragmentoNivel[MAXFILAS][MAXCOLS];

};
#endif
