/*------------------------------*/
/*  Intro a la programac de     */
/*  juegos, por Nacho Cabanes   */
/*                              */
/*   Personaje.h:               */
/*     El "personaje" de        */
/*     Miniminer (version 0.07) */
/*     Fichero de cabecera      */
/*                              */
/*  Comprobado con:             */
/*  - DevC++ 4.9.9.2(gcc 3.4.2) */
/*    y Allegro 4.03 - WinXP    */
/*  - gcc 4.4.3 y Allegro 4.2   */
/*    en Ubuntu Linux 10.04     */
/*------------------------------*/

#ifndef Personaje_h
#define Personaje_h

#include "ElementoGraf.h"
#include "Hardware.h"
#include "Nivel.h"

#define DIREC_DERECHA 0
#define DIREC_IZQUIERDA 1

#define MVTOS_SALTO 20

int pasosSaltoArriba[] = { -6, -6, -6, -6, -4, -4, -2, -2, 0,
                           0, 2, 2, 4, 4, 6, 6, 6, 6 };
                           
class Personaje: public ElementoGraf {

 public:

    Personaje();

    void moverDerecha(Nivel n);
    void moverIzquierda(Nivel n);
    void mover(Nivel n);
    void saltar();
    void saltarDerecha();
    void saltarIzquierda();
    void reiniciarPosicion();
    int getVidas();
    void disminuirVidas();
    void reiniciarVidas();
    
  private:
  
    int xInicial, yInicial;
    int numVidas;
    bool saltando;
    bool cayendo;
    int xInicialSalto, yInicialSalto;
    int desplazVertical, desplazHorizontal;
    int incrXSalto;
    int fotogramaMvto;
};

#endif
