/*------------------------------*/
/*  Intro a la programac de     */
/*  juegos, por Nacho Cabanes   */
/*                              */
/*   Presentacion.cpp:          */
/*     La "presentacion" de     */
/*     Miniminer (version 0.06) */
/*     Fichero de desarrollo    */
/*                              */
/*  Comprobado con:             */
/*  - DevC++ 4.9.9.2(gcc 3.4.2) */
/*    y Allegro 4.03 - WinXP    */
/*  - gcc 4.4.3 y Allegro 4.2   */
/*    en Ubuntu Linux 10.04     */
/*------------------------------*/

#include "Hardware.h"
#include "ElementoGraf.h"
#include "Presentacion.h"

#ifdef __cplusplus
#include <cstdlib>
#else
#include <stdlib.h>
#endif
using namespace std;

/** constructor
 *  y lee los records
 */
Presentacion::Presentacion() {
    cartelFondo.crearDesdeFichero( "miner.bmp" );
    cartelMovil.crearDesdeFichero( "miner_t.bmp" );
}


/** bienvenida: muestra la pantalla de bienvenida
 *  y espera una tecla
 */
int Presentacion::mostrar(Hardware h) {

    int x=100, y=100; // Coordenadas del cartel movil
    int incrX = 2, incrY = 2; // Velocidad del cartel movil
    
    // Absorbo pulsaciones de teclas que lleguen desde el juego
    while ( h.algunaTeclaPulsada() ) 
        h.esperarTecla();
    
    do 
    {
        // Primero muestro el cartel antiguo
        h.borrarOculta();
        cartelFondo.moverA(0,0);
        h.dibujarOculta(cartelFondo);
        
        cartelMovil.moverA(x,y);
        h.dibujarOculta(cartelMovil);
        
        h.visualizarOculta();        
        h.pausa(40);
        
        x += incrX;
        y += incrY;
        
        // Invierto velocidad si llega al borde
        if ((x < 10) || (x > 640-10-174))
            incrX = - incrX;
        if ((y < 10) || (y > 480-10-179))
            incrY = - incrY;
    }
    while ( ! h.algunaTeclaPulsada() );
    
    tecla = h.esperarTecla();
}

bool Presentacion::escogidoFin() {
    return (tecla == TECLA_T);
}
